class EUCstr < String
   @@codec = QTextCodec::codecForName('eucJP')
   def initialize(str=nil)
      if str != nil
         if str.is_a?(QString)
            str = @@codec.fromUnicode(str).to_str
         elsif isUTF?(str)
            qstr = QString::fromUtf8(str)            
            str = @@codec.fromUnicode(qstr).to_str
         else
            str = NKF.nkf('-e', str)
         end
      end
      super(str)
   end

   def substr(*a)
      ary=self.scan(/./me)
      if a.size==1
         if a[0].is_a?(Integer)
            return ary[a[0]]
         elsif a[0].is_a?(Range)
            return ary[a[0]].join
         end
      elsif a.size>1
         return ary[a[0],a[1]].join('')
      end
   end


   def isUTF?(buf)
      return true if buf[0]==0xff && buf[1]==0xfe

      c_count   = 0
      asc_count = 0
      buf.each_byte { |ch|
         if c_count == 0
            asc_count+=1   if  ch>0x1b && ch<=0x7f
            return false   if  ch==0x1b   #JIS
            if ch>=0x80
               if ch>= 0xc0 && ch<=0xdf
                  c_count = 1
               elsif ch>=0xe0 && ch<=0xef
                  c_count = 2
               else
                  return false
               end
            end
         else # c_count > 0
            return false if ch<0x80 || ch>0xbf
            c_count-=1
         end
      }
      return false if asc_count==buf.length  # no Kanji
      return true
   end

   def toUTF
       return @@codec.toUnicode(self)
   end
end
