class Array2 < Array    #󼡸(ˤ⸫)n*n
   def initialize(n)
      @array2Size=n
      super(n*n)      
   end

   def [](a0,a1=nil)
      a0=a1*@array2Size+a0 if a1
      super(a0)
   end
   def []=(a0,a1,a2=nil)
      if a2
         a0=a1*@array2Size+a0
         a1=a2
      end
      super(a0,a1)
   end

   def index(i,j)
      return j*@array2Size+i
   end
   def i2ij(i)
      ii=i%@array2Size
      jj=(i-ii)/@array2Size
      return ii,jj
   end
end

class Board < Array2
   Outside=nil
   NoStone=0
   Black=1
   White=-1
   BlackInitial= 10000
   WhiteInitial=-10000

   MoveErrOutside=1
   MoveErrExist=2
   MoveErrKinsi=3
   MoveErrKo=4
   @@boardForCheck=nil
   @@stack=Array.new
   attr_reader   :size
   attr_accessor :n
   attr_accessor :lastMove
   attr_accessor :capturedStone
   attr_accessor :hamaB
   attr_accessor :hamaW
   attr_accessor :error
   def initialize(size)
      @size=size
      super(@size+2)
      for y in 1..@size
         for x in 1..@size
            self[x,y]=NoStone
         end
      end
      @n=0
      @lastMove=nil
      @capturedStone=Array.new
      @hamaB=0
      @hamaW=0
      @error=nil

      @@boardForCheck=Array2.new(@size+2)
   end


   def each_neighbor_index(i)
      yield(i+1)
      yield(i-1)
      yield(i+@size+2)
      yield(i-@size-2)
   end

   def color(x,y=nil)
      if y==nil
         c=self[x]
         return nil if c==nil
      else
         return nil if x<=0 || x>@size || y<=0 || y>@size
         c=self[x,y]
      end
      return NoStone if c==NoStone
      return Black   if c>0
      return White   if c<0
   end
   protected :color

   def copyBanmenForNext
      bn=self.dup
      bn.n+=1
      bn.capturedStone=Array.new
      bn.lastMove=nil
      bn.error=nil
      return bn
   end
   private :copyBanmenForNext


   def haveDame?(i,col)

      return true if self[i-1]==NoStone||self[i+1]==NoStone||self[i+@size+2]==NoStone||self[i-@size-2]==NoStone

      @@boardForCheck.fill(false)
      @@boardForCheck[i]=true

      @@stack.clear
      @@stack.push(i)
      until @@stack.empty?
         i=@@stack.pop
         each_neighbor_index(i){|ii|
            if not @@boardForCheck[ii]
               c=color(ii)
               return true if c==NoStone

               @@boardForCheck[ii]=true
               @@stack.push(ii) if c==col
            end
         }
      end
      return false
   end

   def ren(i)#Ϣ
      col=color(i)
      return nil if col==NoStone or col==Outside
      ren=Array.new
      @@boardForCheck.fill(false)

      @@stack.clear
      @@stack.push(i)
      until @@stack.empty?
         i=@@stack.pop
         if @@boardForCheck[i]==false
            @@boardForCheck[i]=true
            ren.push(i)
            each_neighbor_index(i){|ii|
               if @@boardForCheck[ii]==false
                  @@stack.push(ii) if color(ii)==col
               end
            }
         end
      end
      ren
   end

   def capture!(i)
      ren=ren(i)
      @capturedStone.concat(ren)
      ren.each{|ii|self[ii]=NoStone}
   end

   def move(col,x=nil,y=nil)
      if col.is_a?(Move)
         x=col.x
         y=col.y
         if x<=0 || x>@size || y<=0 || y>@size
            col.pass
         end
         col=col.color
      else
         if x==nil  # 'B[aa]'
            x=col[2,2]
            col=col[0,1]
         end
         if y==nil  #('B','aa') 
            y=x[1]-?a+1
            x=x[0]-?a+1
         end
      end

      return nil if col!='B' && col!='W' && col!=Black && col!=White

      bNext=copyBanmenForNext

      if x<=0 || x>@size || y<=0 || y>@size
         return bNext
      end
      if color(x,y)!=NoStone
         bNext.error=MoveErrExist
         return  bNext
      end

      col=Black if col=='B'
      col=White if col=='W'
      colOposit=White if col==Black
      colOposit=Black if col==White

      bNext[x,y]=    @n+1  if col==Black
      bNext[x,y] = -(@n+1) if col==White

      haveDameSelf=false
      i=index(x,y)
      each_neighbor_index(i){|ii|
         c=bNext.color(ii)
         if c==colOposit
            if !bNext.haveDame?(ii,colOposit)
               bNext.capture!(ii)
            end
         elsif c==NoStone
            haveDameSelf=true
         end
      }

      if !haveDameSelf
         if !bNext.haveDame?(i,col)
            bNext=copyBanmenForNext
            bNext.error=MoveErrKinsi
            return bNext
         end
      end
      if bNext.capturedStone.size==1
         if @lastMove==bNext.capturedStone[0]
            if @capturedStone.size==1
               bNext=copyBanmenForNext
               bNext.error=MoveErrKo
               return bNext
            end
         end
      end

      bNext.lastMove=index(x,y)
      bNext.hamaB+=bNext.capturedStone.size if col==Black
      bNext.hamaW+=bNext.capturedStone.size if col==White
      return bNext
   end

   def putInitialStone(c,pt)
      b=move(c,pt)
      if b.error==nil
         b[b.lastMove]=BlackInitial if c=='B'
         b[b.lastMove]=WhiteInitial if c=='W'
         b.n=0
         b.hamaB=b.hamaW=0
      end
      return b
   end

   def countArea(deadstoneList)
      a=Array2.new(@size+2)
      a.fill(false)
      each_index{|i|
         next if a[i]
         x,y=i2ij(i)
         if (self[i]==NoStone) || deadstoneList.include?([x,y])
            @@boardForCheck.fill(false)
            @@stack.clear
            @@stack.push(nil)#Ƭ˿򤤤
            searchArea(i,deadstoneList)
            c=@@stack.shift
            c=true if c==nil
            @@stack.each{|j|
               a[j]=c
            }
         end
      }

      b=0
      w=0
      a.each{|c|
         b+=1 if c==:B
         w+=1 if c==:W
      }
      bs=0
      ws=0
      self.each{|c|
         if c
            bs+=1  if c>0
            ws+=1  if c<0
         end
      }
      bdead=0
      wdead=0
      deadstoneList.each{|xy|
         c=self[xy[0],xy[1]]
         bdead+=1  if c>0
         wdead+=1  if c<0 
      }

      s="Japanese\n"
      s<<sprintf("  B:%4d +%3d = %3d\n",b,@hamaB+wdead,b+@hamaB+wdead)
      s<<sprintf("  W:%4d +%3d = %3d\n",w,@hamaW+bdead,w+@hamaW+bdead)
      s<<"\n\nChinese\n"
      s<<sprintf("  B:%4d +%3d = %3d\n",b,bs-bdead,b+bs-bdead)
      s<<sprintf("  W:%4d +%3d = %3d\n",w,ws-wdead,w+ws-wdead)
      return s
   end
   def searchArea(i,deadstoneList)
      return if @@boardForCheck[i]
      @@boardForCheck[i]=true

      @@stack.push(i)
      each_neighbor_index(i){|ii|
         next if self[ii]==nil
         x,y=i2ij(ii)
         if self[ii]==NoStone
            searchArea(ii,deadstoneList)
         elsif deadstoneList.include?([x,y])
            searchArea(ii,deadstoneList)
         elsif self[ii]>0
            @@stack[0]=:D if @@stack[0]==:W
            @@stack[0]=:B if @@stack[0]==nil
         elsif self[ii]<0
            @@stack[0]=:D if @@stack[0]==:B
            @@stack[0]=:W if @@stack[0]==nil
         end
      }
   end

   def toStr #for Test
      str=''
      for y in 1..@size
         s=''+''*(@size-2)+''
         s=''+''*(@size-2)+'' if y==1
         s=''+''*(@size-2)+'' if y==@size
         for x in 1..@size
            if self[x,y]>0
               s[(x-1)*2,2]=''
            elsif self[x,y]<0
               s[(x-1)*2,2]=''
            end
         end
         str+=s+"\n"
      end
      return str
   end
end


