class Warning < QMessageBox
   def initialize(w,s='',err=nil)
      if s.is_a?(Class)
         if s==Board
            case err
            when Board::MoveErrKinsi
               s=EUCstr.new('ػ').toUTF
            when Board::MoveErrKo
               s=EUCstr.new('ϼ֤ޤ').toUTF
            when Board::MoveErrExist
               s=EUCstr.new('Фޤ').toUTF
            end
         end
      end
      super('',s,QMessageBox::Warning,1,0,0,w,'')
   end
end

class ConfirmDialog < QMessageBox
   Save=1
   Quit=2
   def initialize(w,s)
      if s==Save
         s="ߤδ¸Ƥޤ\n"
         s+='Ǥ?'
         s=EUCstr.new(s).toUTF
      elsif s==Quit
         s="ߤδ¸Ƥޤ\n"
         s<<'λƤǤ?'
         s=EUCstr.new(s).toUTF
      end
      super('',s,QMessageBox::Information,QMessageBox::Yes,QMessageBox::No,QMessageBox::NoButton,w,'')
   end
end

class FileDialog < QDialog
   MaxSize=1024*50

   class FileListBox < QListBox
      def showFileList(mode,dir)
         dirlist =Array.new
         filelist=Array.new
         Dir.foreach(dir) {|filename|
            file=File.expand_path(filename,dir)
            next if !FileTest.readable?(file)
            if FileTest.directory?(file) then
               if FileTest.executable?(file) then
                  next if filename=='.' || filename=='..'
                  dirlist.push filename
               end
            elsif FileTest.file?(file)
               next if mode!='r' && !FileTest.writable?(file)
               next if mode=='r' && !FileTest.readable?(file)
               filelist.push filename
            end
         }
         if FileTest.readable?(File.expand_path('..',dir))
            if dir !='/'
               insertItem('../')
            end
         end
         dirlist.sort!
         dirlist.each{|file|
            insertItem(file+'/')
         }
         filelist.sort!
         filelist.each{|file|
            insertItem(file)
         }
         setSelected(0,true)
      end
   end

   attr_reader :selectedFile

   def initialize( parent=nil,mode='r')
      name=''
      modal=true
      super(parent, name, modal)

      @mode=mode
      @selectedFile=nil

      begin
         @pwd= Dir.pwd
      rescue
         @pwd=ENV['HOME']
         Dir.chdir(@pwd)
      end

      @myAcceptSignal=RSignal.new

      move(50,5)
      box=QVBox.new(self)
      box.resize(400,400)
      @label = QLabel.new(Dir.pwd,box,'')
      @label.setAlignment(AlignRight)
      @list  = FileListBox.new(box)
      @list.showFileList(@mode,@pwd)
      @input  = QLineEdit.new(box,'')

      button = QHButtonGroup.new('',box,'')
      ok     = QPushButton.new('ok',button,'')
      cancel = QPushButton.new('cancel',button,'')
      QLabel.new('  ',button)
      zaurus = QPushButton.new('~/',button,'')
      mnt    = QPushButton.new('/mnt/',button,'')

      connect( @list, QSIGNAL("clicked(QListBoxItem*)"), self, 'fileSelect')
      connect( @list, QSIGNAL("returnPressed(QListBoxItem*)"), self, 'fileSelect')

      connect( zaurus, QSIGNAL("clicked()"), self, 'gotoHome' )
      connect( mnt, QSIGNAL("clicked()"), self, 'gotoMnt' )
      connect( ok, QSIGNAL("clicked()"), self, 'myAccept' )

      connect( @input, QSIGNAL("returnPressed()"), self, 'myAccept' )
      connect( cancel, QSIGNAL("clicked()"), self,QSLOT("reject()") )
      connect(@myAcceptSignal,self,QSLOT("accept()"))
   end

   def changeDir(dir)
      @pwd=dir
      @input.setText('')
      @label.setText(@pwd)
      @list.clear
      @list.showFileList(@mode,@pwd)
      return
   end
   def gotoHome
      changeDir(ENV['HOME'])
   end
   def gotoMnt
      changeDir('/mnt/')
   end

   def myAccept
      filename = @input.text.to_str
      if filename.empty?
         return if  @list.currentItem<0
         filename=@list.currentText.to_str
      end
      filename=File.expand_path(filename,@pwd)

      if FileTest.directory?(filename)
         if !FileTest.exist?(filename)
            Warning.new(self,'no such directory').exec
            @input.setText('')
            return
         elsif !FileTest.readable?(filename)||!FileTest.executable?(filename)
            Warning.new(self,'permission denied').exec
            @input.setText('')
            return
         end
         changeDir(filename)
         return
      end
      if filename[-1]==?/
         Warning.new(self,'no such directory').exec
         @input.setText('')
         return
      end

      dir=File.dirname(filename)
      if !FileTest.exist?(dir)
         Warning.new(self,'no such directory').exec
         @input.setText('')
         return
      end

      if @mode=='r'
         if !FileTest.exist?(filename) then
            Warning.new(self,'no such file or directory').exec
            @input.setText('')
            return
         elsif !FileTest.readable?(dir)||!FileTest.readable?(filename)
            Warning.new(self,'permission denied').exec
            @input.setText('')
            return
         end
      else
         if !FileTest.writable?(dir)
            Warning.new(self,'permission denied').exec
            @input.setText('')
            return
         end
         if FileTest.exist?(filename) then
            if !FileTest.writable?(filename)
               Warning.new(self,'permission denied').exec
               @input.setText('')
               return
            end
            s=filename
            s+="\nϴ¸ߤޤ\n"
            s+='񤭤ޤ?'
            s=EUCstr.new(s).toUTF
            r=ConfirmDialog.new(self,s).exec
            return if r!=QMessageBox::Yes
         end
      end

      if @mode=='r'
         if FileTest.size(filename) >= MaxSize then
            Warning.new(self,'file is too big').exec
            return
         end
      end
      @selectedFile=filename

      @myAcceptSignal.send
   end

   def fileSelect(fileItem)
      return if fileItem==nil
      if fileItem.text.to_str == @input.text.to_str
         myAccept
      else
         @input.setText(fileItem.text.to_str)
      end
   end
end

class AddCommentDialog < QDialog
   MaxWidth=600
   MinWidth=233
   TextLarge=EUCstr.new('').toUTF
   TextSmall=EUCstr.new('̾').toUTF

   def initialize( parent=nil, name='' ,str='')
      modal=true
      super(parent, name, modal)
      move(0,4)
      @box=QVBox.new(self)
      @box.setMinimumSize(MinWidth,430)

      hbox = QHBox.new(@box)
      QLabel.new(' ',hbox,'')      
      @changeSize = QPushButton.new(TextLarge,hbox,'')
      @changeSize.setMaximumWidth(70)
      @changeSize.setMaximumHeight(26)
      connect( @changeSize, QSIGNAL("clicked()"), self,'changeSize' )
     
      @txtArea=QMultiLineEdit.new(@box)
      @txtArea.setFont(QFont.new('lcfont',18))
      @txtArea.setWordWrap(1)   #WidgetWidth
      @txtArea.setWrapPolicy(1) #Anywhere
      @txtArea.setText(str)
      @txtArea.setText(str)
      @txtArea.setFocus()

      button = QHButtonGroup.new('',@box,'')
      ok     = QPushButton.new('ok',button,'')
      cancel = QPushButton.new('cancel',button,'')

      connect( ok, QSIGNAL("clicked()"), self, QSLOT("accept()"))
      connect( cancel, QSIGNAL("clicked()"), self,QSLOT("reject()") )

   end
   def text
       return @txtArea.text
   end
   def changeSize
       if @box.width<MaxWidth
          @changeSize.setText(TextSmall)
          @box.setMinimumWidth(MaxWidth)
          @box.setMaximumWidth(MaxWidth)
       else
          @changeSize.setText(TextLarge)
          @box.setMinimumWidth(MinWidth)
          @box.setMaximumWidth(MinWidth)
       end
       adjustSize
   end
end

class OkigoDialog < QDialog
   Nkind=9
   Label=['Ҷ','Ҷ()','Ҷ()',\
          'ͻҶ','޻Ҷ','ϻҶ','Ҷ','ȬҶ',\
          'Ҷ' ]
   Okiisi=[\
          ['dp','pd'],\
          ['dp','pd','pp'],\
          ['dp','dd','pd'],\
          ['dp','dd','pd','pp'],\
          ['dp','dd','pd','pp','jj'],\
          ['dp','dd','pd','pp','dj','pj'],\
          ['dp','dd','pd','pp','dj','pj','jj'],\
          ['dp','dd','pd','pp','dj','pj','jd','jp'],\
          ['dp','dd','pd','pp','dj','pj','jd','jp','jj'],\
          ]

   attr_reader :okiisi

   def initialize( parent=nil, name='' ,str='')
      modal=true
      super(parent, name, modal)
      move(10,5)

      box=QVBox.new(self)
      box.resize(220,430)

      QLabel.new(' ',box,'')
      @bGroup=QVButtonGroup.new('',box, '')
      @bGroup.setExclusive(true)
      @radioBtn=Array.new(Nkind)
      @radioBtn.each_index{|i|
         s=EUCstr.new(Label[i]).toUTF
         @radioBtn[i]=QRadioButton.new(s,@bGroup,'')
      }
      @radioBtn[0].setChecked(true) 
      connect( @bGroup, QSIGNAL('pressed(int)'), self, 'slotSelect()' )

      QLabel.new(' ',box,'')
      button = QHButtonGroup.new('',box,'')
      ok     = QPushButton.new('ok',button,'')
      cancel = QPushButton.new('cancel',button,'')
      ok.setDefault(true)
      connect( ok, QSIGNAL("clicked()"), self,QSLOT("accept()") )
      connect( cancel, QSIGNAL("clicked()"), self,QSLOT("reject()") )

      @okiisi= Okiisi[0]
   end

   def slotSelect(i)
      @okiisi= Okiisi[i]
   end
end

class GameinfoDialog < QDialog
   def initialize(info,mode,parent=nil,name='')
      modal=true
      super(parent, name, modal)
      move(0,4)
      setFont(QFont.new('lcfont',18))

      fEdit=(mode=='e')
      box=QVBox.new(self)
      box.setMinimumSize(250,430)
      @lineEdit=Hash.new

      QLabel.new(' ',box,'')
      ['B','W'].each{|c|
         hbox=QHBox.new(box)
         s=EUCstr.new('').toUTF
         s=EUCstr.new('').toUTF if c=='W'
         QLabel.new(s,hbox,'')
         @lineEdit['P'+c]=QLineEdit.new(hbox)
         @lineEdit[c+'R']=QLineEdit.new(hbox)
         @lineEdit[c+'R'].setMaximumWidth(80)
      }

      QLabel.new(' ',box,'')
      s={'RE'=>'','KM'=>'','HA'=>'',\
         'DT'=>'','PC'=>'','EV'=>'̾',\
         'SO'=>'ŵ'} 
      ['RE','KM','HA','DT','PC','EV','SO'].each{|p|
         hbox=QHBox.new(box)
         str=EUCstr.new(s[p]+'').toUTF
         QLabel.new(str,hbox,'')
         @lineEdit[p]=QLineEdit.new(hbox)
         QLabel.new(' ',box,'') if p=='HA' || p=='EV'
      }

      ['PB','BR','PW','WR','RE',\
       'HA','KM','DT','PC','EV','SO'].each{|p|
         @lineEdit[p].setReadOnly(true) if !fEdit
         next if info[p]==nil
         @lineEdit[p].setText(EUCstr.new(info[p][0]).toUTF) 
      }
     
      QLabel.new(' ',box,'')
      button = QHButtonGroup.new('',box,'')
      ok     = QPushButton.new('ok',button,'')
      connect( ok, QSIGNAL("clicked()"), self, QSLOT("accept()"))
      if fEdit
         cancel = QPushButton.new('cancel',button,'')
         connect( cancel, QSIGNAL("clicked()"), self,QSLOT("reject()") )
      end      
   end
   attr_accessor :lineEdit
end

class GotoNumberDialog < QDialog
   def initialize(parent,initval,maxval)
      name=''
      modal=true
      super(parent, name, modal)
      move(10,10)

      box=QVBox.new(self)
      box.setMinimumSize(200,200)
      @spin=QSpinBox.new(0,maxval,1,box,'')
      @spin.setButtonSymbols(QSpinBox::PlusMinus)
      @spin.setValue(initval)
      @spin.setMinimumHeight(50)
      slider = QSlider.new(Horizontal,box,'')
      slider.setRange( 0,maxval )
      slider.setValue( initval )
      slider.setMinimumHeight(50)
      connect( slider, QSIGNAL("valueChanged(int)"), @spin, "setValue(int)" )
      connect( @spin, QSIGNAL("valueChanged(int)"), slider, "setValue(int)" )
      button = QHButtonGroup.new('',box,'')
      button.setMaximumHeight(60)
      ok     = QPushButton.new('ok',button,'')
      cancel = QPushButton.new('cancel',button,'')
      connect( ok, QSIGNAL("clicked()"), self, QSLOT("accept()"))
      connect( cancel, QSIGNAL("clicked()"), self,QSLOT("reject()") )
   end
   def value
      return @spin.value
   end
end

class TextGobanDialog < QDialog
   def initialize( parent=nil, name='' ,str='')
      modal=true
      super(parent, name, modal)
      move(0,0)

      box=QVBox.new(self)
      box.setMinimumSize(400,400)

      @txtArea=QMultiLineEdit.new(box)
      @txtArea.setFont(QFont.new('lcfont',16))
      @txtArea.setWordWrap(1)   #WidgetWidth
      @txtArea.setWrapPolicy(1) #Anywhere
      @txtArea.setText(str)
      @txtArea.setText(str)
      @txtArea.selectAll

      ok     = QPushButton.new('ok',box,'')
      connect( ok, QSIGNAL("clicked()"), self, QSLOT("accept()"))
   end
end
