class GameTree < Array
   def initialize(boardSize=19)
      super(0)
      @iRoot=0
      @i=@iRoot
      self[@iRoot]=Node.new
      @sz=boardSize
      @edited=false

      @propFF='3'
      @propPL=nil
      @propAB=PropValue.new
      @propAW=PropValue.new
      @gameinfo=Hash.new

      @branchPointStack=Array.new
      @lastBranchPoint=Array.new
      @nextBranchPoint=nil
      @lastComment=Array.new
      @nextComment=nil
      @lastNumber=0
      @mainLastNumber=0

   end
   def currentNode
      return self[@i]
   end
   def currentIndex
      return @i
   end
   def rootNode
      return self[@iRoot]
   end
   def sz
      return @sz
   end
   def edited?
      return @edited
   end
   def setEdited(b)
      @edited = (b==true)
   end
   def inBranch?
      return !@branchPointStack.empty?
   end
   def lastComment?
      return !@lastComment.empty?
   end
   def lastBranchPoint?
      return !@lastBranchPoint.empty?
   end
   attr_reader   :nextComment
   attr_reader   :nextBranchPoint
   attr_reader   :lastNumber
   attr_accessor :propPL
   attr_accessor :gameinfo

   def analyze
      if self[@iRoot].move!=nil
         iRootSav=@iRoot
         self.push(Node.new)
         @iRoot=self.length-1
         self[iRootSav].parent=@iRoot
         self[@iRoot].addChild(0)
         self[iRootSav].propList.each_pair{|key,val|
            if key!='C'
               self[@iRoot].addProp(key,val)
               self[iRootSav].propList.delete(key)
            end
         }
         @i=@iRoot
      end
 
      i=@iRoot
      while !self[i].child.empty?
         ich=self[i].child[0]
         break if self[ich].move != nil
         i=ich
      end
      iSetupLast=i

      i=@iRoot
      while i!=iSetupLast
         i=self[i].child[0]
         if i==nil
            p iSetupLast
            exit
         end
         self[i].propList.each_pair{|key,val|
            if self[@iRoot].propList[key]==nil
               self[@iRoot].addProp(key,val)
            end
         }
      end
      if iSetupLast!=@iRoot
         self[@iRoot].child.clear
         self[iSetupLast].child.each{|ich|
            self[@iRoot].addChild(ich)
            self[ich].parent=@iRoot
         }
      end

      rn=self[@iRoot]
      if rn.propList['FF']!=nil
         ff=rn.propList['FF'][0]
         @propFF=ff if ff=='1'||ff=='4'
      end

      sz=rn.propList['SZ']
      if sz!=nil && !sz.empty?
         sz=sz[0].to_i
         if sz>0 && sz<=19
            @sz=sz
         end
      end
      pv=PropValue.new
      pv[0]=@sz.to_s
      rn.propList.delete('SZ')
      rn.addProp('SZ',pv)

      rn.setBoard(Board.new(@sz))

      PropList::PropGameinfo.each{|pn|
         if rn.propList[pn]!=nil
            if @gameinfo[pn]==nil
               @gameinfo[pn]=PropValue.new
               @gameinfo[pn].push(rn.propList[pn][0])
            end
         end
      }

      pl=rn.propList['PL']
      if pl!=nil && pl[0]=='W'
         @propPL='W'
      end
      if !rn.child.empty?
         ich=rn.child[0]
         if self[ich].move != nil
            if self[ich].move.color=='B'
               @propPL=nil
            else
               @propPL='W'
            end
         end
      end

      ['B','W'].each{|c|
         pn='A'+c
         if rn.propList[pn]!=nil
            rn.propList[pn].each{|pv|
               if pv =~ /^[a-s][a-s]$/
                  x=pv[0]-?a+1
                  y=pv[1]-?a+1
                  if x<=@sz && y<=@sz
                     addInitialStone(c,x,y)
                  end
               elsif pv =~ /^[a-s][a-s]\:[a-s][a-s]$/
                  x0=pv[0]-?a+1
                  y0=pv[1]-?a+1
                  x1=pv[3]-?a+1
                  y1=pv[4]-?a+1
                  if x0<=x1&&y0<=y1&&x1<=@sz&&y1<=@sz
                     for xx in x0..x1
                        for yy in y0..y1
                           addInitialStone(c,xx,yy)
                        end
                     end
                  end
               end
            }
         end
      }

      nextCommentSearch
      nextBranchPointSearch
      lastNumberSearch
      @mainLastNumber=@lastNumber
   end

   def addInitialStone(col,x,y)
      pt=(?a+x-1).chr+(?a+y-1).chr
      b=self[@iRoot].board.putInitialStone(col,pt)
      if b.error==nil
         @propAB.push(pt) if col=='B'
         @propAW.push(pt) if col=='W'
         self[@iRoot].setBoard(b)
         b.capturedStone.each{|i|
            x,y=b.i2ij(i)
            p=(?a+x-1).chr+(?a+y-1).chr 
            @propAW.delete(p) if col=='B'
            @propAB.delete(p) if col=='W'
         }
      end
      return b.error
   end
   def removeInitialStone(x,y)
      pt=(?a+x-1).chr+(?a+y-1).chr
      b=self[@iRoot].board.dup
      c=b[x,y]
      if c==Board::BlackInitial||c==Board::WhiteInitial
         b[x,y]=0
         self[@iRoot].setBoard(b)
         if c==Board::BlackInitial
            @propAB.delete(pt)
         else
            @propAW.delete(pt)
         end
      end
   end
   def removeInitialStoneAll
      return nil if @propAB.empty? && @propAW.empty?
      b=self[@iRoot].board.dup
      @propAB.each{|pt|
         y=pt[1]-?a+1
         x=pt[0]-?a+1
         b[x,y]=0
      }
      @propAW.each{|pt|
         y=pt[1]-?a+1
         x=pt[0]-?a+1
         b[x,y]=0
      }
      self[@iRoot].setBoard(b)
      @propAB.clear
      @propAW.clear
      true
   end

   def putOkiisi(okiisi)
      @propAB.clear
      @propAW.clear
      b=Board.new(@sz)

      okiisi.each{|pt|
         b=b.putInitialStone('B',pt)
         @propAB.push(pt)
      }
      self[@iRoot].setBoard(b)

      pv=PropValue.new
      pv.push(okiisi.length.to_s)
      @gameinfo['HA']=pv
   end

   def makeMove!
      bPar=self[self[@i].parent].board
      return nil if !bPar.is_a?(Board)
      if self[@i].move==nil
         b=bPar
      else
         b=bPar.move(self[@i].move)
      end
      self[@i].setBoard(b)
      return b
   end
   private :makeMove!

   def prev
      iPar=self[@i].parent
      return nil if iPar==nil

      if self[iPar].child[0]==@i
         fChonan=true
         if self[@i].propList['C']!=nil
            @nextComment=@i
         end
      else
        fChonan=false
      end

      @i=iPar
       
      if self[@i].child[0]==@branchPointStack.last
         @branchPointStack.pop
      end
      if @i==@lastBranchPoint.last
         @lastBranchPoint.pop
      end
      if @i==@lastComment.last
         @lastComment.pop
      end
      if self[@i].child.size>1
         @nextBranchPoint=self[@i].child[0]
      end
      nextCommentSearch if !fChonan
      if !fChonan
         if inBranch?
            lastNumberSearch
         else
            @lastNumber=@mainLastNumber
         end
      end
      return self[@i]
   end

   def gotoChild(i=nil)
      i=0 if i==nil
      return nil if self[@i].child[i]==nil
      if i>0
         @branchPointStack.push(self[@i].child[0])
      end
      if self[@i].parent!=nil&&self[self[@i].parent].child.size>1
         @lastBranchPoint.push(@i)
      end
      if self[@i].propList['C']!=nil
         @lastComment.push(@i)
      end

      @i=self[@i].child[i]
      makeMove! if self[@i].board==nil   

      if i==0
         nextCommentSearch if @i==@nextComment
      else
         nextCommentSearch
         lastNumberSearch
      end
      if self[self[@i].parent].child.size>1
         nextBranchPointSearch
      end
      return self[@i]
   end

   def gotoVariation(i)
      iPar=self[@i].parent
      return nil if iPar==nil 
      return nil if self[iPar].child[i]==nil
      prev
      gotoChild(i)
   end

   def returnFromBranch
      i=@branchPointStack.pop
      return nil if i==nil
      while self[@i].child[0]!=i
         prev
      end
      gotoChild(0)
      return self[@i]
   end

   def gotoLastBranchPoint
      i=@lastBranchPoint.pop
      return nil if i==nil
      while @i!=i
         prev
      end
   end

   def gotoNextBranchPoint
      return nil if @nextBranchPoint==nil
      i=@nextBranchPoint
      while @i!=i
         break if gotoChild(0)==nil
      end
   end
   def nextBranchPointSearch
      @nextBranchPoint=nil
      i=@i
      while !self[i].child.empty?
         if self[i].child.size>1
            @nextBranchPoint=self[i].child[0]
            break
         end
         i=self[i].child[0]
      end
      return @nextComment
   end
   private :nextBranchPointSearch

   def gotoLastComment
      i=@lastComment.pop
      return nil if i==nil
      while @i!=i
         prev
      end
   end

   def gotoNextComment
      return nil if @nextComment==nil
      i=@nextComment
      while @i!=i
         break if gotoChild(0)==nil
      end
   end
   def nextCommentSearch
      @nextComment=nil
      i=@i
      while !self[i].child.empty?
         i=self[i].child[0]
         if self[i].propList['C']!=nil
            @nextComment=i
            break
         end
      end
      return @nextComment
   end

   def gotoNumber(nn)
      if self[@i].board.n<nn
         while self[@i].board.n<nn
            break if self[@i].child.empty?
            gotoChild(0) 
         end 
      elsif self[@i].board.n>nn
         while self[@i].board.n>nn
            break if self[@i].parent==nil
            prev
         end
      end
   end
   def lastNumberSearch
      i=@i
      n=self[i].board.n
      while !self[i].child.empty?
         i=self[i].child[0] 
         n+=1 if self[i].move !=nil
      end
      @lastNumber=n
   end

   def goBackToStone(x,y)
      return nil if x<1||y<1||x>@sz||y>@sz
      return nil if self[@i].board[x,y]==Board::NoStone
      return nil if self[@i].parent==nil
      while self[@i].parent!=nil && self[self[@i].parent].board[x,y]!=Board::NoStone
         prev
      end
   end

   def current2Initial
      b=self[@i].board
      self.each{|node|
         node.setBoard(nil)
      }

      @propPL=nil
      i=@i
      while self[i].parent!=nil&&!self[i].move.is_a?(Move)
         i=self[i].parent
      end
      if self[i].move.is_a?(Move)
         if self[i].move.color=='B'
            @propPL='W'
         end
      end

      self.push(Node.new)
      @iRoot=self.length-1
      self[@iRoot].setBoard(Board.new(@sz))
      self[@iRoot].child=self[@i].child
      self[@i].child.each{|i|
         self[i].parent=@iRoot
      }

      @propAB.clear
      @propAW.clear
      for y in 1..b.size
      for x in 1..b.size
          if b[x,y]>0
             addInitialStone('B',x,y)
          elsif b[x,y]<0
             addInitialStone('W',x,y)
          end
      end
      end

      @i=@iRoot
      nextCommentSearch
      nextBranchPointSearch
      lastNumberSearch
      @mainLastNumber=@lastNumber
      @branchPointStack.clear
      @lastBranchPoint.clear
      @lastComment.clear

      @edited=true
   end

   KakuageToA =0
   Kakuage1   =1
   Kakusage1  =2
   KakusageToZ=3

   def kakuage(mode)
      iPar=self[@i].parent
      return nil if iPar==nil
      return nil if self[iPar].child.size<=1
      if mode==KakuageToA||mode==Kakuage1
         return nil if self[iPar].child[0]==@i
      else
         return nil if self[iPar].child.last==@i
      end

      iSave=@i
      prev
      idx=self[@i].child.index(iSave)
      case mode
      when KakuageToA
         iDst=0
         self[@i].child.delete_at(idx)
         self[@i].child.unshift(iSave)
      when Kakuage1
         iDst=idx-1
         self[@i].child[idx] =self[@i].child[iDst]
         self[@i].child[iDst]=iSave
      when Kakusage1
         iDst=idx+1
         self[@i].child[idx] =self[@i].child[iDst]
         self[@i].child[iDst]=iSave
      when KakusageToZ
         iDst=self[@i].child.size-1
         self[@i].child.delete_at(idx)
         self[@i].child.push(iSave)
      end

      nextCommentSearch
      if !inBranch?
         lastNumberSearch
         @mainLastNumber=@lastNumber
      end
      gotoChild(iDst)
      @edited=true
   end

   def removeCurrentNode
      iSave=@i
      inMain = !inBranch?
      return if prev==nil
      self[@i].child.delete(iSave)

      if inMain
         iSave=@i
         @i=@iRoot
         lastNumberSearch
         @mainLastNumber=@lastNumber
         @i=iSave
      end
      nextBranchPointSearch
      nextCommentSearch

      @edited=true
   end

   def addChild(node)
      self.push(node)
      ich=self.length-1
      self[@i].addChild(ich)
      self[ich].parent=@i

      if self[@i].child.size==1
         @lastNumber+=1
         @mainLastNumber+=1 if !inBranch?
      end
      @edited=true
      return self[@i].child.size-1
   end

   def moveStone(x,y)
      cn=currentNode
      return if cn.board[x,y]!=Board::NoStone
      return if cn.move==nil

      deleteBoard #currentλҰʹ
      cn.setBoard(nil)
      c =cn.move.color
      pt=(x-1+?a).chr<<(y-1+?a).chr
      newMove=Move.new(c,pt)
      cn.move=newMove

      i=@i
      prev
      ii=currentNode.child.index(i)
      gotoChild(ii)
      @edited=true
   end

   def deleteBoard
      self[@i].child.each{|ii|
         deleteBoard2(ii)
      }
   end
   def deleteBoard2(i) # called from deleteBoard
      self[i].setBoard(nil)
      while self[i].child.size==1
         i=self[i].child[0]
         self[i].setBoard(nil)
      end
      self[i].child.each{|ii|
         deleteBoard2(ii)
      }
   end

   def newMove?(col,x,y)
      ch=self[@i].child
      i=true
      ch.each_index{|ich|
         m=self[ch[ich]].move
         if m!=nil
            if m.color==col && m.x==x && m.y==y
               i=ich
               break
            end
         end
      }
      return i
   end

   def nextMoveColor
      c='B'
      i=@i
      while self[i].move==nil && i!=@iRoot
         i=self[i].parent
      end
      if i==@iRoot
         c='W' if @propPL=='W'
         return c
      end
      c='W' if self[i].move.color=='B'
      return c
   end

   def rootNode2SGF
      sgf=';'
      sgf+='FF['+@propFF+']'
      sgf+='GM[1]'
      sgf+='SZ['+@sz.to_s+"]\n"
      nch=0
      @gameinfo.each_key{|pn|
         next if @gameinfo[pn]==nil
         next if @gameinfo[pn][0]==''
         s=pn+@gameinfo[pn].toSGF
         sgf<<s
         nch+=s.size
         if nch>=SGF::LineLength
            sgf<<"\n"
            nch=0
         end
      }
      sgf<<self[@iRoot].propList.toSGF
      if @propPL=='W'
         sgf<<"\n" if sgf[-1].chr!="\n"
         sgf<<'PL[W]'
      end
      if !@propAB.empty?
         @propAB.sort!
         sgf<<"\n" if sgf[-1].chr!="\n"
         sgf+='AB'+@propAB.toSGF
      end
      if !@propAW.empty?
         @propAW.sort!
         sgf<<"\n" if sgf[-1].chr!="\n"
         sgf+='AW'+@propAW.toSGF
      end
      return sgf
   end
   def toSGF
      @sgf='('
      @sgf<<rootNode2SGF
      @sgf<<"\n" if @sgf[-1].chr!="\n"
      @sgfNch=0
      toSGF2(@iRoot)
      @sgf<<"\n" if @sgf[-1].chr!="\n"
      @sgf<<")\n"
      GC.start
      return SGF.new(@sgf)
   end
   def toSGF2(i)# called only from toSGF
      while self[i].child.size==1
         i=self[i].child[0]
         s=self[i].toSGF
         @sgf<<s
         @sgfNch+=s.size
         if @sgfNch>=SGF::LineLength
            @sgf<<"\n" if @sgf[-1].chr!="\n"
            @sgfNch=0
         end
      end
      if self[i].child.size>1
         self[i].child.each{|ich|
            @sgf<<"\n" if @sgf[-1].chr!="\n"
            @sgf<<"("
            @sgfNch=1
            s=self[ich].toSGF
            @sgf<<s
            @sgfNch+=s.size
            if @sgfNch>=SGF::LineLength
               if !self[ich].child.empty?
                  @sgf<<"\n" if @sgf[-1].chr!="\n"
                  @sgfNch=0
               end
            end
            toSGF2(ich)
            @sgf<<")"
            @sgfNch+=1
         }
      end
   end
   private :toSGF2

   def saveStatus(*mode)
      c=dup
      c.clear
      c=Marshal.load(Marshal.dump(c))
      each_index{|i|
         c[i]=self[i]
      }
      mode.each{|m|
         if m==:current
            self[@i]=self[@i].semiDeepCopy
         elsif m==:root
            self[@iRoot]=self[@iRoot].semiDeepCopy
         elsif m==:parent
            iPar=self[@i].parent
            if iPar!=nil
               self[iPar]=self[iPar].semiDeepCopy
            end
         elsif m==:all
            self.each_index{|i|
               self[i]=self[i].semiDeepCopy
            }
         end
      }
      c
   end

end
