class ViewVBox < QVBox
   def initialize
      super
      setFrameStyle(QFrame::Box)
      setMargin(10)
      setMaximumHeight(410)
   end
end

class InitialBoardView < ViewVBox
   attr_reader :putOkiisiSignal
   attr_reader :ok
   attr_reader :allDelete
   def initialize()
      super()
      s=EUCstr.new('Ф').toUTF
      @bGroup=QVButtonGroup.new(s,self, '')
      @bGroup.setExclusive(true)
      s=EUCstr.new('').toUTF
      @bb=QRadioButton.new(s,@bGroup,'')
      s=EUCstr.new('').toUTF
      bw=QRadioButton.new(s,@bGroup,'')
      s=EUCstr.new('').toUTF
      bbw=QRadioButton.new(s,@bGroup,'')
      s=EUCstr.new('').toUTF
      bwb=QRadioButton.new(s,@bGroup,'')
      s=EUCstr.new('').toUTF
      brm=QRadioButton.new(s,@bGroup,'')
      @bb.setChecked(true) 
      connect(@bGroup,QSIGNAL('clicked(int)'),self,'select')

      box2=QVBox.new(self)
      box2.setSpacing(10)
      s=EUCstr.new('õ').toUTF
      @allDelete = QPushButton.new(s,box2,'')

      s=EUCstr.new('').toUTF
      @okigoButton = QPushButton.new(s,box2,'')
      connect(@okigoButton, QSIGNAL("clicked()"), self, 'okigo')

      s=EUCstr.new('򤫤ǤϤ').toUTF      
      @bpl=QCheckBox.new(s,box2,'')

      @ok = QPushButton.new('ok',self,'')

      @putOkiisiSignal=RSignal.new('Object')
      @color='B'
   end

   def select(id)
      if id==0||id==2
         @color='B'
      elsif id==1||id==3
         @color='W'
      else
         @color=nil
      end
      if id==2||id==3
         @toggle=true
      else
         @toggle=false
      end
   end

   def color
      c=@color
      if @toggle
         if @color=='B'
            @color='W'
         elsif @color=='W'
            @color='B'
         end
      end
      return c
   end
   def setPL(c)
      @bpl.setChecked(c=='W')
   end
   def pl
      return 'W' if @bpl.isChecked
      return nil
   end
   def reset(sz)
      @bb.setChecked(true)
      @color='B'
      @toggle=false
      @okigoButton.setEnabled(sz==19)
   end
     
   def okigo
      okigoDialog=OkigoDialog.new(self)
      r=okigoDialog.exec
      if r==QDialog::Accepted
         @putOkiisiSignal.sendWith(okigoDialog.okiisi)
         @bpl.setChecked(true)
      end
   end

   def focusChange
      return nil if @ok.hasFocus

      f=false
      (0..@bGroup.count()-1).each{|i|
         if @bGroup.find(i).hasFocus
            f=true
            break
         end
      }
      if f
         @allDelete.setFocus()
      elsif @allDelete.hasFocus
         @okigoButton.setFocus()
      elsif @okigoButton.hasFocus
         @bpl.setFocus()
      elsif @bpl.hasFocus
         @ok.setFocus()
      else
         @bGroup.selected.setFocus()
      end
      return true
   end
end

class PutMarkView < ViewVBox
   MKchar = { 'CR' => '','MA' => '',\
              'SQ' => '','TR' => '','SL' => ''  }

   def initialize()
      super()

      @pn=Hash.new

      @bGroup=QButtonGroup.new(self, '')
      @bGroup.hide
      @bGroup.setExclusive(true)

      QLabel.new(' ',self,'')

      boxLB=QHBox.new(self)
      s=EUCstr.new('ʸ ').toUTF
      @bLB=QRadioButton.new(s,boxLB,'')
      @bLB.setChecked(true)
      id=@bGroup.insert(@bLB,-1)
      @pn[id]='LB'
      @lineEditLB=QLineEdit.new(boxLB,'')
      @lineEditLB.setMaxLength(1)
      @lineEditLB.setMaximumWidth(50)
      connect(@lineEditLB,QSIGNAL('textChanged(const QString&)'),self,'textChanged')
      dummy=QLabel.new(' ',boxLB,'')
      boxLB.setStretchFactor(dummy, 10)      

      boxLB2=QHBox.new(self)
      s=EUCstr.new('ʸ ').toUTF
      @bLB2=QRadioButton.new(s,boxLB2,'')
      id=@bGroup.insert(@bLB2,-1)
      @pn[id]='LB2'
      @lineEditLB2=QLineEdit.new(boxLB2,'')
      @lineEditLB2.setMaxLength(1)
      @lineEditLB2.setMaximumWidth(50)
      connect(@lineEditLB2,QSIGNAL('textChanged(const QString&)'),self,'textChanged2')
      s=EUCstr.new('').toUTF
      QLabel.new(s,boxLB2,'')
     

      ['MA','CR','TR','SQ','SL'].each{|pn|
         s=MKchar[pn]+' ('+pn+')'
         s=EUCstr.new(s).toUTF
         b=QRadioButton.new(s,self,'')
         id=@bGroup.insert(b,-1)
         @pn[id]=pn
      }
      s=EUCstr.new('õ').toUTF
      b=QRadioButton.new(s,self,'')
      id=@bGroup.insert(b,-1)
      @pn[id]=''

      QLabel.new(' ',self,'')
      s=EUCstr.new('õ').toUTF
      @bAllDelete = QPushButton.new(s,self,'')

      QLabel.new(' ',self,'')
      @ok = QPushButton.new('ok',self,'')
   end
   attr_reader :bAllDelete
   attr_reader :ok


   def textChanged(s)
      @bLB.setChecked(true)
   end
   def textChanged2(s)
      @bLB2.setChecked(true)
   end

   def propName
      b=@bGroup.selected()
      return nil if b==nil
      id=@bGroup.id(b)
      pn=@pn[id]
      if pn=='LB'
         return nil if lbChr==''
      elsif pn=='LB2'
         return nil if lbChr2==''
      end
      return pn
   end

   def lbChr
      return EUCstr.new(@lineEditLB.text)
   end
   def lbChr2
      return EUCstr.new(@lineEditLB2.text)
   end

   def lb2Succ
      s=EUCstr.new(@lineEditLB2.text)
      s=s.succ
      @lineEditLB2.setText(s.toUTF)
   end

   def focusChange
      return nil if @ok.hasFocus

      f=false
      (0..@bGroup.count()-1).each{|i|
         if @bGroup.find(i).hasFocus
            b=@bGroup.selected()
            if b && @pn[@bGroup.id(b)]=='LB'
               @lineEditLB.setFocus
               return true
            end
            f=true
            break
         end
      }
      if f
         @bAllDelete.setFocus()
      elsif @lineEditLB.hasFocus
         @bAllDelete.setFocus()
      elsif @bAllDelete.hasFocus
         @ok.setFocus()
      else
         @bGroup.selected.setFocus()
      end
      return true
   end
   def reset
      @bLB.setChecked(true)
   end
end


class GoBackToStoneView < ViewVBox
   def initialize()
      super()

      s=EUCstr.new(' ФꤷƤ').toUTF
      label = QLabel.new(s,self,'')
      @cancel = QPushButton.new('cancel',self,'')
   end
   attr_reader :cancel
end

class CountAreaView < ViewVBox
   def initialize()
      super()
      label = QLabel.new('',self,'')
      s=EUCstr.new('ФꤷƲ').toUTF
      label = QLabel.new(s,self,'')

      label = QLabel.new('',self,'')
      @txtArea=QMultiLineEdit.new(self)

      label = QLabel.new(' ',self,'')
      s=EUCstr.new('λ').toUTF
      @ok = QPushButton.new(s,self,'')
   end
   attr_reader :ok
   attr_reader :txtArea
   def reset
      @txtArea.clear
   end
end

class MoveStoneView < ViewVBox
   def initialize()
      super()

      s=EUCstr.new('Фưޤ').toUTF
      label = QLabel.new(s,self,'')
      label.setAlignment(Qt::WordBreak)
      s=EUCstr.new('ưꤷƤ').toUTF
      label = QLabel.new(s,self,'')
      label.setAlignment(Qt::WordBreak)

      label = QLabel.new(' ',self,'')
      label = QLabel.new(' ',self,'')
      s=EUCstr.new('cancel').toUTF
      @cancel = QPushButton.new(s,self,'')
   end
   attr_reader :cancel
end
